#include "Autonome.h"

unsigned long __stdcall ExecutionGenerique (void *p)
{
   Autonome *pAutonome = reinterpret_cast<Autonome *> (p);
   while (!pAutonome->DoitMourir ())
   {
      pAutonome->Agir ();
      ::Sleep (pAutonome->GetDelai ());
   }
   pAutonome->Deceder ();
   return 0L;
}

Autonome::~Autonome ()
{
   Arreter ();
}
void Autonome::Demarrer ()
{
   DWORD id;
   m_hTh = ::CreateThread (0, 0, ExecutionGenerique, this, 0, &id);
}

void Autonome::Arreter ()
{
   if (!EstMort ())
   {
      Meurs ();
      ::WaitForSingleObject (m_hTh, INFINITE);
      ::CloseHandle (m_hTh);
   }
}
