#ifndef AUTONOME_H
#define AUTONOME_H

#include <windows.h>

typedef unsigned long tDelai;

class Autonome
{
   HANDLE m_hTh;
   tDelai m_Delai;
   bool m_DoitMourir;
   bool m_EstMort;
public:
   virtual void Agir () = 0;
   Autonome (const tDelai Delai = 0)
      : m_Delai (Delai), m_DoitMourir (false), m_EstMort (false)
   {
   }
   tDelai GetDelai () const { return m_Delai; }
   bool DoitMourir () const { return m_DoitMourir; }
   void Meurs () { m_DoitMourir = true; }
   bool EstMort () const { return m_EstMort; }
   void Deceder () { m_EstMort = true; }
   virtual ~Autonome ();
   void Demarrer ();
   void Arreter ();
};

#endif // !defined AUTONOME_H
